=== debian/changelog ===
dlt-daemon (2.18.0-1) unstable; urgency=low

  * New upstream release

 -- Aigars Mahinovs <aigarius@debian.org>  Sun, 03 Feb 2019 13:50:12 +0200
